<template>
  <div class="edit-input-wrapper" :style="{'transform-origin': 'top left', ...editConfig}" v-if="displayEditor">
    <!-- <v-text-field
      outlined
      filled
      dense
      class="v-text-edit"
      background-color="white"
      :value="message"
      @keydown="onKeyDown"
    /> -->
    <input type="range" :value="message.value" :min="message.minValue" :max="message.maxValue" @change="onSliderChange" step="0.1" />
  </div>
</template>

<script type="ts">
  import { mapState, mapMutations } from 'vuex'
  import store from '@/store'
  import { getParameters } from '@/lib/audio/utils/parameters'

  export default {
    name: 'Editor',
    computed: {
      ...mapState(["editConfig", "editedParam", "displayEditor"]),
      message: state => {
        const paramDetails = getParameters(state.editedParam.node.name, state.editedParam.name);
        const message = {
          ...paramDetails,
          value: state.editedParam.param.value
        }
        return message;
      }
    },
    methods: {
      ...mapMutations(["cancelEdition"]),
      onKeyDown(e) {
        if(e.key === "Enter") {
          store.commit("validateEdition", e.target.value)
        }
      },
      onSliderChange(e) {
        store.commit("validateEdition", e.target.value)
      }
    },
  }
</script>

<style>
  .edit-input-wrapper {
    width: 150px;
    position: absolute;
    z-index: 7;
  }
</style>
